BookShop/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('accounts/', include('django.contrib.auth.urls')),
]

main/urls.py
from django.urls import path
from . import views


urlpatterns = [
    path('', views.BookListView.as_view(), name='books'),
    path('books/create', views.CreateBooksView.as_view(), name='create'),
    path('books/<id>/edit/', views.BookEdit.as_view(), name='edit'),
    path('supply', views.SupplyListView.as_view(), name='supply'),
    path('sales', views.SalesListView.as_view(), name='sales'),
    path('sales/create', views.CreateSalesView.as_view(), name='create_sales'),
    path('supply/create_supply', views.CreateSupplyView.as_view(), name='create_supply'),
    path('accounts/logout', views.logout_view, name='loggetout'),
    path('account', views.account, name='account'),
]

main/models.py
from django.db import models


class Supply(models.Model):
    date = models.DateField(
        verbose_name='Дата поставки'
    )
    count = models.IntegerField(
        verbose_name='Количество поставленных книг',
        blank=True, null=True
    )

    def __str__(self):
        return self.date


class Book(models.Model):
    name = models.CharField(
        verbose_name='Наименование',
        max_length=1024,
    )
    author = models.CharField(
        verbose_name='Автор',
        max_length=1024
    )
    publishing = models.CharField(
        verbose_name='Издательство',
        max_length=1024
    )
    year_publication = models.IntegerField(
        verbose_name='Год издания'
    )
    count = models.IntegerField(
        verbose_name='Количество экзмепляров'
    )
    price = models.FloatField(
        verbose_name='Цена'
    )
    purchase_price = models.FloatField(
        verbose_name='Закупочкая цена'
    )

    supply = models.ManyToManyField(
        to=Supply,
        related_name='supplys',
        verbose_name='Поставка',
        blank=True, null=True
    )

    def __str__(self):
        return self.name


class Sale(models.Model):
    client = models.CharField(
        verbose_name='Клиент',
        max_length=1024,
    )
    employee = models.CharField(
        verbose_name='Сотрудник',
        max_length=1024,
    )
    book = models.ManyToManyField(
        verbose_name='Книги',
        to='main.Book',
    )
    cost = models.FloatField(
        verbose_name='Сумма',
    )

    def __str__(self):
        return self.cost

    @property
    def get_books(self):
        books = [' - '.join((book.name, str(book.price) + ' рублей')) for book in self.book.all()]
        return books

main/views.py
from django.contrib.auth import logout
from django.shortcuts import render, redirect
from django.views import View
from django.views.generic import ListView, CreateView

from .form import BookForm, SupplyForm, SaleForm
from .models import Book, Supply, Sale


class BookListView(ListView):
    template_name = 'books.html'
    model = Book


class CreateBooksView(CreateView):
    template_name = 'create.html'
    form_class = BookForm

    def post(self, request, *args, **kwargs):
        form = BookForm(request.POST)

        if form.is_valid():
            response = form.save(commit=False)
            response.user = request.user
            response.save()
            return redirect('books')
        return render(request, 'create.html', context={'form': form})


class BookEdit(View):
    def get(self, request, id):
        book = Book.objects.get(id=id)
        form = BookForm(instance=book)
        return render(request, 'edit.html', context={'form': form, 'book': book})

    def post(self, request, id):
        book = Book.objects.get(id=id)
        form = BookForm(request.POST, instance=book)
        if form.is_valid():
            form.save()
            return redirect('books')
        return render(request, 'edit.html', context={'form': form, 'book': book})


class SupplyListView(ListView):
    template_name = 'supply.html'
    model = Book

    def get_queryset(self):
        return Book.objects.filter()


class CreateSupplyView(CreateView):
    template_name = 'create_supply.html'
    form_class = SupplyForm

    def post(self, request, *args, **kwargs):
        form = SupplyForm(request.POST)

        if form.is_valid():
            book_id = int(form.cleaned_data['book_name'])
            date = form.cleaned_data['date']
            count_books = int(form.cleaned_data['count_books'])

            supply = Supply.objects.create(date=date, count=count_books)
            book = Book.objects.get(id=book_id)
            book.supply.add(supply)
            book.count += count_books
            book.save()
            return redirect('supply')

        return render(request, 'create_supply.html', context={'form': form})


class SalesListView(ListView):
    template_name = 'sales.html'
    model = Sale


class CreateSalesView(CreateView):
    template_name = 'create_sales.html'
    form_class = SaleForm

    def post(self, request, *args, **kwargs):
        form = SaleForm(request.POST)

        if form.is_valid():
            client = form.cleaned_data['client']
            employee = form.cleaned_data['employee']
            books = form.cleaned_data['books']

            cost = sum(books.values_list('price', flat=True))

            sale = Sale.objects.create(
                client=client,
                employee=employee,
                cost=cost
            )
            sale.book.add(*books)
            return redirect('sales')
        return render(request, 'create_sales.html', context={'form': form})


def logout_view(request):
    logout(request)
    return redirect('books')


def account(request):
    return render(request, 'account.html', context={'user': request.user})

main/templates/account.html
{% extends 'base.html' %}

{% block title %}
    Аккаунт
{% endblock %}

{% block content %}
    <div class="container mt-5">
        <h2> Ваш логин: {{ user.username }} </h2>
        <h3>
            {% if user.is_superuser %}
                Вы являтесь сотрудником
            {% endif %}
        </h3>
    </div>
{% endblock %}

main/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.9.3/dist/umd/popper.min.js" integrity="sha384-W8fXfP3gkOKtndU4JGtKDvXbO53Wy8SZCQHczT5FMiiqmQfUpWbYdTil/SxwZgAN" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.min.js" integrity="sha384-skAcpIdS7UcVUC05LJ9Dxay8AXcDYfBJqt1CJ85S/CFujBsIzCIv+l9liuYLaMQ/" crossorigin="anonymous"></script>

    <title>
        {% block title %}
        {% endblock %}
    </title>
</head>
<body>
<header class="p-3 bg-dark text-white">
    {% if user.is_authenticated and user.is_superuser %}
        <div class="container">
            <div class="d-flex flex-wrap align-items-center justify-content-center justify-content-lg-start">
                <ul class="nav col-12 col-lg-auto me-lg-auto mb-2 justify-content-center mb-md-0">
                  <li><a href="{% url 'books' %}" class="nav-link px-2 text-white">Книги</a></li>
                  <li><a href="{% url 'supply' %}" class="nav-link px-2 text-white">Поставки</a></li>
                  <li><a href="{% url 'sales' %}" class="nav-link px-2 text-white">Продажи</a></li>
                  <li><a href="{% url 'account' %}" class="nav-link px-2 text-white">Аккаунт</a></li>
                </ul>

                <div class="text-end">
                  <a href="{% url 'loggetout' %}" class="btn btn-warning">Выйти</a>
                </div>
            </div>
        </div>
    {% elif user.is_authenticated and not user.is_superuser %}
        <div class="container">
            <div class="d-flex flex-wrap align-items-center justify-content-center justify-content-lg-start">
                <ul class="nav col-12 col-lg-auto me-lg-auto mb-2 justify-content-center mb-md-0">
                  <li><a href="{% url 'books' %}" class="nav-link px-2 text-white">Книги</a></li>
                  <li><a href="{% url 'account' %}" class="nav-link px-2 text-white">Аккаунт</a></li>
                </ul>

                <div class="text-end">
                  <a href="{% url 'loggetout' %}" class="btn btn-warning">Выйти</a>
                </div>
            </div>
        </div>
    {% else %}
        <div class="container">
            <div class="d-flex flex-wrap align-items-center justify-content-center justify-content-lg-start">
                <ul class="nav col-12 col-lg-auto me-lg-auto mb-2 justify-content-center mb-md-0">
                  <li><a href="{% url 'books' %}" class="nav-link px-2 text-white">Книги</a></li>
                </ul>

                <div class="text-end">
                  <a href="{% url 'login' %}" class="btn btn-warning">Войти</a>
                </div>
            </div>
        </div>
    {% endif %}
</header>
    {% block content %}
    {% endblock %}
</body>
</html>

main/templates/books.html
{% extends 'base.html' %}

{% block title %}
    Книги
{% endblock %}

{% block content %}
    <div class="container mt-5">
        <div class="list-group">
            {% for book in book_list %}
            <a href="{% if user.is_superuser %}{%  url 'edit' id=book.id %}{% endif %}"
               class="list-group-item list-group-item-action flex-column align-items-start">
                <div class="d-flex w-100 justify-content-between">
                    <h5 class="mb-1">{{ book.name}}</h5>
                    <small>{{ book.count}} штук</small>
                </div>
                <p class="mb-1">Издательство: {{ book.publishing }} - {{ book.year_publication }} г.</p>
                <small>{{ book.price }} рублей</small>
            </a>
            {% endfor %}
            <br>
        </div>

        {% if user.is_superuser %}
            <a class="btn btn-primary" href="{% url 'create' %}" role="button">Добавить книгу</a>
        {% endif %}
    </div>
{% endblock %}

main/templates/create.html
{% extends 'base.html' %}

{% block title %}
    Книги
{% endblock %}

{% block content %}
<div class="container mt-5">
    <h2>Создание книги</h2>
    <form action="{% url 'create' %}" method="post">
        <div class="form-group">
            {% csrf_token %}
            {% for field in form %}
                <input type="text" name="{{ field.name }}" id="{{ field.name }}" class="form-control" placeholder="{{ field.label }}"><br>
            {% endfor %}
        </div>
        <button type="submit" class="btn btn-primary">Создать</button>
    </form>
</div>
{% endblock %}

main/templates/create_sales.html
{% extends 'base.html' %}

{% block title %}
    Поставка
{% endblock %}

{% block content %}
<div class="container mt-5">
    <h2>Поставка</h2>
    <form action="{% url 'create_sales' %}" method="post">
        {% csrf_token %}
        <div class="form-group">
            {{ form.books }} <br>
            <input type="text" name="{{ form.client.name }}" id="{{ form.client.name }}" class="form-control" placeholder="{{ form.client.label }}"><br>
            <input type="text" name="{{ form.employee.name }}" id="{{ form.employee.name }}" class="form-control" placeholder="{{ form.employee.label }}"><br>
        </div>
        <button type="submit" class="btn btn-primary">Создать</button>
    </form>
</div>
{% endblock %}

main/templates/create_supply.html
{% extends 'base.html' %}

{% block title %}
    Поставка
{% endblock %}

{% block content %}
<div class="container mt-5">
    <h2>Поставка</h2>
    <form action="{% url 'create_supply' %}" method="post">
        {% csrf_token %}
        <div class="form-group">
            {{ form.book_name }} {{ form.book_name.errors }} <br>
            <input type="number" name="{{ form.count_books.name }}" id="{{ form.count_books.name }}" class="form-control" placeholder="{{ form.count_books.label }}"><br>
            <input type="date" name="{{ form.date.name }}" id="{{ form.date.name }}" class="form-control" placeholder="{{ form.date.label }}"><br>
        </div>
        <button type="submit" class="btn btn-primary">Создать</button>
    </form>
</div>
{% endblock %}

main/templates/edit.html
{% extends 'base.html' %}

{% block title %}
    Книги
{% endblock %}

{% block content %}
<div class="container mt-5">
    <h2>Редактирование книги</h2>
    <form action="{% url 'edit' id=book.id%}" method="post">
        <div class="form-group">
            {% csrf_token %}
            {% for field in form %}
                <input type="text" name="{{ field.name }}" id="{{ field.name }}" class="form-control" value="{{ field.value }}" placeholder="{{ field.label }}"><br>
            {% endfor %}
        </div>
        <button type="submit" class="btn btn-primary">Изменить</button>
    </form>
</div>
{% endblock %}

main/templates/sales.html
{% extends 'base.html' %}

{% block title %}
    Книги
{% endblock %}

{% block content %}
    <div class="container mt-5">
        <div class="list-group">
            {% for sale in sale_list %}
            <a href="#"
               class="list-group-item list-group-item-action flex-column align-items-start">
                <div class="d-flex w-100 justify-content-between">
                    <h5 class="mb-1">{{ sale.cost }} рублей</h5>
                </div>
                {% for book in sale.get_books %}
                    <p class="mb-1">{{ book }}</p>
                {% endfor %}
                <small>Клиент: {{ sale.client }}. Сотрудник: {{ sale.employee }}</small>
            </a>
            {% endfor %}
            <br>
        </div>

        {% if user.is_superuser %}
            <a class="btn btn-primary" href="{% url 'create_sales' %}" role="button">Добавить продажу</a>
        {% endif %}
    </div>
{% endblock %}

main/templates/supply.html
{% extends 'base.html' %}

{% block title %}
    Поставки
{% endblock %}

{% block content %}
    <div class="container mt-5">
        <div class="list-group">
            {% for book in book_list %}
            <a href=""{% if user.is_superuser %}{%  url 'edit' id=book.id %}{% endif %}"
                class="list-group-item list-group-item-action flex-column align-items-start">
                <div class="d-flex w-100 justify-content-between">
                    <h5 class="mb-1">{{ book.name }}</h5>
                </div>
                <p class="mb-1">Издательство: {{ book.publishing }} - {{ book.year_publication }} г.</p>
                <ul class="list-group">
                    {% for supply in book.supply.all %}
                        <li class="list-group-item">Дата поставки: {{ supply.date }} - {{ supply.count }} штук</li>
                    {% endfor %}
                </ul>
            </a>
            {% endfor %}
            <br>
        </div>
        {% if user.is_superuser %}
            <a class="btn btn-primary" href="{% url 'create_supply' %}" role="button">Добавить поставку</a>
        {% endif %}
    </div>
{% endblock %}